<?php

function db_connect()
{
  global $db;

  $dsn = sprintf('%s:host=%s;dbname=%s', DBDRIVER, DBHOST, DBNAME);
  $db = new PDO($dsn, DBUSER, DBPASS);
}

function db_error()
{
  global $db;

  $info = $db->errorInfo();

  return $info[2];
}

function db_lastid($table)
{
  global $db;

  if (DBDRIVER == 'pgsql')
    $sql = sprintf("SELECT currval('%s_id_seq')", $table);
  elseif (DBDRIVER == 'mysql')
    $sql = "SELECT last_insert_id()";
  else
    die("Unsupported database driver");

  $sth = $db->query($sql);
  $row = $sth->fetch();
  return $row[0];
}

function query_db($sql)
{
  global $db;

  $sth = $db->query($sql);

  if ($sth === false) return false;

  $result = array();
  while ($row = $sth->fetch())
    $result[] = $row;

  return $result;
}

?>