<?php

function discover_cmp($a, $b)
{
  return strcmp($a['id'],$b['id']);
}

function discover_masks()
{
  $info = array();

  if (($modules = opendir($_SESSION['sys']['basedir'].'masks')) === false)
    return $info;

  while (($module = readdir($modules)) !== false)
    if (is_dir($_SESSION['sys']['basedir'].'masks/'.$module)
	&& $module != '.' && $module != '..') {

      if (($d = opendir($_SESSION['sys']['basedir'].'masks/'.$module)) === false)
	continue;

      while (($file = readdir($d)) !== false)
	if (substr($file,-4) == '.php') {
	  $fname = substr($file,0,-4);
	  $info[] = array('id' => $module.'|'.$fname, 'text' => $module.'|'.$fname);
	}
      closedir($d);
    }
  closedir($modules);

  usort($info,discover_cmp);
  return $info;
}

$mask = array(
	      'table' => 'sys_mask',
	      'title' => 'Liste der Menüpunkte',
	      'join' => array('sys_menu ON sys_mask.menu = sys_menu.id'),
	      'list' => array(
			      'id' => array(
					    'name' => 'ID',
					    'visible' => false,
					    'sql' => 'sys_mask.id',
					    ),
			      'fname' => array(
					    'name' => 'Dateiname',
					    'width' => 170,
					    ),
			      'name' => array(
					    'name' => 'Name',
					    'width' => 150,
					    'sql' => 'sys_mask.name',
					    ),
			      'menutitle' => array(
					    'name' => 'Menüpunkt',
					    'width' => 100,
					    ),
			      'menu' => array(
					    'name' => 'Menü',
					    'sql' => 'sys_menu.name',
					    'width' => 100,
					    ),
			      'edit' => array(
					    'name' => 'Edit',
					    'width' => 40,
					    'specs' => "ClassName: 'aligncenter', canSort: false",
					    ),
			      'priority' => array(
					    'name' => 'Priorität',
					    'width' => 60,
					    'type' => 'number',
					    'specs' => "ClassName: 'alignright', canSort: false",
					    'sql' => 'sys_mask.priority',
					    ),
			      ),
	      'edit' => array(
			      'fname' => array(
					    'name' => 'Dateiname',
					    'type' => 'select',
					    'options' => discover_masks(),
					    'options_string' => true,
					    ),
			      'name' => array(
					    'name' => 'Name',
					    'type' => 'text',
					    'size' => 24,
					    ),
			      'menutitle' => array(
					    'name' => 'Menüpunkt',
					    'type' => 'text',
					    'size' => 24,
					    'required' => true,
					    ),
			      'title' => array(
					    'name' => 'Beschreibung',
					    'type' => 'text',
					    'size' => 24,
					    'null' => true,
					    ),
			      'menu' => array(
					    'name' => 'Menü',
					    'type' => 'select',
					    'options' => 'SELECT id,name AS text FROM sys_menu ORDER BY name',
					    ),
			      'edit' => array(
					    'name' => 'Edit',
					    'type' => 'boolean',
					    ),
			      'shadow' => array(
					    'name' => 'shadow',
					    'type' => 'boolean',
					    ),
			      'priority' => array(
					    'name' => 'Priorität',
					    'type' => 'number',
					    'size' => 10,
					    ),
			      ),
	      );

?>
